#pragma once
#include <string>
#include "config.h" 
#include "gui.h"
#include "fontutil.h"
#include "buttonActionMap.h"
#include "raylib.h"

enum class menuEnum 
{
    game = 0, settingScreen, exit
};

class Menu
{
    public :
        void Init(int width, int height, std::string title); 
        void Tick();
        Menu();
        ~Menu();

    private: 
        void Draw(); 
        void Update(); 
        void KeyboardInputCheck();
        void KeyboardButtonCheck();
        bool IsActionPressed();

        std::vector<std::string> texts;
        // GUI button; 
        GUI* button[3];
        
        Font font;

        menuEnum menuState;

        int gamepad = 0; // 제일 처음에 꽂은 게임패드만 사용하도록 하자. 제일 처음이므로 0이다. 
};

